/* $Header: /CVSROOT/debris/cmds/get.c,v 1.1 2005/08/13 22:59:12 tino Exp $
 *
 * DebRIS: DEBian Remote Install Scripter
 * *get <offset> <length> <file>
 *
 * $Log: get.c,v $
 * Revision 1.1  2005/08/13 22:59:12  tino
 * additional functions, see ChangeLog
 *
 */

static int
driscmd_get(char *args)
{
  const char	*n;
  int		fd, got;
  long long	pos;
  char		*end;
  long		len;
  char		buf[BUFSIZ*10];

  n	= nextarg(&args);
  pos	= strtoull(n, &end, 0);
  if (*end || !*n || pos<0)
    return err("get: debris sends funny offset %s", n);

  n	= nextarg(&args);
  len	= strtoul(n, &end, 0);
  if (*end || !*n || len<0)
    return err("get: debris sends funny length %s", n);

  if ((fd=open(args, O_RDONLY))<0)
    return err("get: cannot open %s", args);
  if (lseek(fd, (off_t)pos, SEEK_SET)!=pos)
    return err("get: cannot seek to %lld", pos);

  while ((got=readall(fd, buf, sizeof buf))>0)
    dris_buf_add(config.out, buf, got);

  if (close(fd))
    return err("get: cannot close %s", args);

  if (got<0)
    return err("get: read error %s", args);

  return 0;
}
